check_updates
=============

This module contains several function implementing rules that restrict certain
subset of update commands on a table. These functions are designed to be set as
on update per-row triggers on a table.

Development is sponsored by Enova Financial (http://www.enova.com)

To build it, just do this:

    make
    make installcheck
    make install

If you encounter an error such as:

    "Makefile", line 8: Need an operator

You need to use GNU make, which may well be installed on your system as
`gmake`:

    gmake
    gmake install
    gmake installcheck

If you encounter an error such as:

    make: pg_config: Command not found

Be sure that you have `pg_config` installed and in your path. If you used a
package management system such as RPM to install PostgreSQL, be sure that the
`-devel` package is also installed. If necessary tell the build process where
to find it:

    env PG_CONFIG=/path/to/pg_config make && make installcheck && make install

And finally, if all that fails (and if you're on PostgreSQL 8.1 or lower, it
likely will), copy the entire distribution directory to the `contrib/`
subdirectory of the PostgreSQL source tree and try it there without
`pg_config`:

    env NO_PGXS=1 make && make installcheck && make install

If you encounter an error such as:

    ERROR:  must be owner of database regression

You need to run the test suite using a super user, such as the default
"postgres" super user:

    make installcheck PGUSER=postgres

Once check_updates is installed, you can add it to a database. If you're running
PostgreSQL 9.1.0 or greater, it's a simple as connecting to a database as a
super user and running:

    CREATE EXTENSION check_updates;

If you've upgraded your cluster to PostgreSQL 9.1 and already had check_updates
installed, you can upgrade it to a properly packaged extension with:

    CREATE EXTENSION check_updates FROM unpackaged;

Note: upgrades are not supported from version 1.0.0

For versions of PostgreSQL less than 9.1.0, you'll need to run the
installation script:

    psql -d mydb -f /path/to/pgsql/share/contrib/check_updates.sql
	psql -d mydb -f /path/to/pgsql/share/contrib/allow_on_condition.sql
	psql -d mydb -f /path/to/pgsql/share/contrib/deny_updates.sql

If you want to install check_updates and all of its supporting objects into a specific
schema, use the `PGOPTIONS` environment variable to specify the schema, like
so:

    PGOPTIONS=--search_path=extensions psql -d mydb -f check_updates.sql
	PGOPTIONS=--search_path=extensions psql -d mydb -f deny_updates.sql
	PGOPTIONS=--search_path=extensions psql -d mydb -f allow_on_condition.sql

Dependencies
------------
The `check_updates` module has no dependencies other than PostgreSQL.

Copyright and License
---------------------

The module is distributed under the PostgreSQL License.
Copyright (c) 2012 Command Prompt, Inc.

